#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <time.h>
#include "file_open.h"

struct STRINGS {
	size_t lines;
	char **buf;
} str;
size_t n_flag;
FILE *o_flag;

void free_strings(char print_flag) {
	if (str.buf == NULL)
		return;

	size_t num = 0;
	for (size_t i = 0; i <= str.lines; i++)
		if (str.buf[i] != NULL) {
			if (print_flag) {
				if (n_flag == 0)
					fprintf(o_flag, "%s", str.buf[i]);

				else if (num < n_flag) {
					size_t r = rand() % str.lines;
					fprintf(o_flag, "%s", str.buf[r]);
					num++;
				}
			}

			free(str.buf[i]);
		}

	free(str.buf);
}

static char read_file(FILE *fp) {
	char *line = NULL;
	ssize_t bytes = 0;
	size_t n = 0;

	str.buf = malloc(sizeof(char *));
	if (str.buf == NULL)
		goto RF_ERROR;

	while ((bytes = getline(&line, &n, fp)) != -1) {
		char **tmp = realloc(str.buf, sizeof(char *) * (str.lines + 2));
		if (tmp == NULL)
			goto RF_ERROR;

		str.buf = tmp;

		str.buf[str.lines] = strdup(line);
		if (str.buf[str.lines] == NULL)
			goto RF_ERROR;

		str.lines++;

	}

	if (line)
		free(line);

	return 0;

RF_ERROR:
	fprintf(stderr, "shuf: read file: %s\n", strerror(errno));
	free_strings(0);
	return 1;
}

int main(int argc, char **argv) {
	srand(time(NULL));
	o_flag = stdout;

	char *p;
	int opt;
	while ((opt = getopt(argc, argv, "o:n:")) != -1) {
		switch (opt) {
			case 'o':
				o_flag = file_open("shuf", optarg, "w");
				if (o_flag == NULL)
					return 1;

				break;

			case 'n':
				n_flag = strtoul(optarg, &p, 10);
				break;

			default:
				printf("shuf -[on]\n\t-n NUM Output at most NUM lines\n\t-o STR Write to FILE\n");
				return 0;
		}
	}

	argv += optind;
	argc -= optind;

	char *file = argv[0];
	if (argc == 0)
		file = "-";

	FILE *fp = file_open("shuf", file, "r");
	if (fp == NULL)
		goto ERROR;

	if (read_file(fp) == 1)
		goto ERROR;

	/* Shuf */
	if (n_flag == 0) {
		for (size_t i = 0; i < str.lines; i++) {
			char *tmp = str.buf[i];

			size_t r = rand() % str.lines;
			str.buf[i] = str.buf[r];
			str.buf[r] = tmp;
		}
	}

	/* Free and print */
	free_strings(1);
	return 0;

ERROR:
	if (o_flag != stdout)
		fclose(o_flag);

	if (fp != NULL)
		fclose(fp);

	return 1;
}
